Index: DCWoRMS/branches/coolemall/src/schedframe/resources/devices/description/PhysicalResourceDescription.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/devices/description/PhysicalResourceDescription.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/devices/description/PhysicalResourceDescription.java	(revision 1415)
@@ -30,4 +30,5 @@
 import schemas.PowerUsage;
 import schemas.Profile;
+import schemas.StringValueWithUnit;
 import simulator.utils.InstanceFactory;
 import example.energy.DefaultEnergyEstimationPlugin;
@@ -82,4 +83,26 @@
 				}
 				Parameters params = extractParameters(powerProfileCharacteristic.getEnergyEstimationPlugin().getParameter());
+				if(powerProfileCharacteristic.getEnergyEstimationPlugin().getPowerCapLevel() != null) {
+					Parameter param = new Parameter("powerCapLevel");
+					StringValueWithUnit sv = new StringValueWithUnit();
+					sv.setContent(String.valueOf(powerProfileCharacteristic.getEnergyEstimationPlugin().getPowerCapLevel().getContent()));
+					sv.setUnit(powerProfileCharacteristic.getEnergyEstimationPlugin().getPowerCapLevel().getUnit());
+					param.add(sv);
+					
+					if(params == null)
+						params = new Parameters();
+					params.put("powerCapLevel", param);
+				}
+				if(powerProfileCharacteristic.getEnergyEstimationPlugin().getPowerFloorLevel() != null) {
+					Parameter param = new Parameter("powerFloorLevel");
+					StringValueWithUnit sv = new StringValueWithUnit();
+					sv.setContent(String.valueOf(powerProfileCharacteristic.getEnergyEstimationPlugin().getPowerFloorLevel().getContent()));
+					sv.setUnit(powerProfileCharacteristic.getEnergyEstimationPlugin().getPowerFloorLevel().getUnit());
+					param.add(sv);
+					
+					if(params == null)
+						params = new Parameters();
+					params.put("powerFloorLevel", param);
+				}
 				energyEstimationPlugin.init(params);
 			}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/devices/DeviceAirflowInterface.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/devices/DeviceAirflowInterface.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/devices/DeviceAirflowInterface.java	(revision 1415)
@@ -7,6 +7,6 @@
 
 import schedframe.Parameters;
-import schedframe.resources.computing.profiles.energy.EnergyEvent;
-import schedframe.resources.computing.profiles.energy.EnergyEventType;
+import schedframe.resources.computing.profiles.energy.ResourceEvent;
+import schedframe.resources.computing.profiles.energy.ResourceEventType;
 import schedframe.resources.computing.profiles.energy.airthroughput.AirflowValue;
 import schedframe.resources.computing.profiles.energy.airthroughput.AirflowProfile;
@@ -37,6 +37,6 @@
 			
 			//TO DO - notifications should be called for all resources starting form the lowest layer
-			resource.handleEvent(new EnergyEvent(EnergyEventType.AIRFLOW_STATE_CHANGED, resource.getFullName()));
-			resource.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, resource.getFullName()));
+			resource.handleEvent(new ResourceEvent(ResourceEventType.AIRFLOW_STATE_CHANGED, resource.getFullName()));
+			resource.handleEvent(new ResourceEvent(ResourceEventType.POWER_STATE_CHANGED, resource.getFullName()));
 			return true;
 		}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/devices/Fan.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/devices/Fan.java	(revision 1274)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/devices/Fan.java	(revision 1415)
@@ -4,4 +4,5 @@
 import java.util.List;
 
+import schedframe.resources.computing.ComputingResource;
 import schedframe.resources.devices.description.DeviceDescription;
 
@@ -12,8 +13,14 @@
 	public Fan(DeviceDescription devDesc) {
 		super(devDesc);
-		this.chilledResources = new ArrayList<String>();
 	}
 	
 	public List<String> getChilledResources(){
+		if(chilledResources == null){
+			List<String> resNames =  new ArrayList<String>();
+			for(ComputingResource compRes: this.getComputingResource().getChildren()){
+				resNames.add(compRes.getFullName());
+			}
+			return resNames;
+		}
 		return chilledResources;
 	}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/devices/PhysicalResource.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/devices/PhysicalResource.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/devices/PhysicalResource.java	(revision 1415)
@@ -12,4 +12,5 @@
 import schedframe.resources.computing.extensions.ExtensionType;
 import schedframe.resources.computing.profiles.energy.EnergyExtension;
+import schedframe.resources.computing.profiles.energy.ResourceEvent;
 import schedframe.resources.computing.profiles.energy.airthroughput.ui.AirflowInterface;
 import schedframe.resources.computing.profiles.energy.power.ui.PowerInterface;
@@ -28,5 +29,5 @@
 
 	
-	public abstract void handleEvent(Event event);
+	public abstract void handleEvent(ResourceEvent event);
 	
 	public abstract EventHandler getEventHandler();
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/units/StandardResourceUnitName.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/units/StandardResourceUnitName.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/units/StandardResourceUnitName.java	(revision 1415)
@@ -37,5 +37,5 @@
     COST("cost"),
     
-    PE("processingElement");
+    PE("processingelement");
 
     
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/load/LoadExtension.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/load/LoadExtension.java	(revision 1285)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/load/LoadExtension.java	(revision 1415)
@@ -7,6 +7,6 @@
 import schedframe.resources.computing.extensions.ExtensionException;
 import schedframe.resources.computing.extensions.ExtensionType;
-import schedframe.resources.computing.profiles.energy.EnergyEvent;
-import schedframe.resources.computing.profiles.energy.EnergyEventType;
+import schedframe.resources.computing.profiles.energy.ResourceEvent;
+import schedframe.resources.computing.profiles.energy.ResourceEventType;
 import schedframe.resources.computing.profiles.load.ui.LoadInterface;
 import schedframe.resources.devices.PhysicalResource;
@@ -29,13 +29,13 @@
 		if(loadProfile == null || loadProfile.getLoadEstimationPlugin() == null)
 			return false;
-		if(event.getType().getName().equals(EnergyEventType.POWER_STATE_CHANGED.getName()))
+		if(event.getType().getName().equals(ResourceEventType.POWER_STATE_CHANGED.getName()))
 			return true;
-		else if(event.getType().getName().equals(EnergyEventType.FREQUENCY_CHANGED.getName()))
+		else if(event.getType().getName().equals(ResourceEventType.CPU_FREQUENCY_CHANGED.getName()))
 			return true;
-		else if(event.getType().getName().equals(EnergyEventType.TASK_STARTED.getName()))
+		else if(event.getType().getName().equals(ResourceEventType.TASK_STARTED.getName()))
 			return true;
-		else if(event.getType().getName().equals(EnergyEventType.TASK_FINISHED.getName()))
+		else if(event.getType().getName().equals(ResourceEventType.TASK_FINISHED.getName()))
 			return true;
-		else if(event.getType().getName().equals(EnergyEventType.RESOURCE_UTILIZATION_CHANGED.getName()))
+		else if(event.getType().getName().equals(ResourceEventType.UTILIZATION_CHANGED.getName()))
 			return true;		
 		else return false;
@@ -44,5 +44,5 @@
 	public void handleEvent(Event event) {
 		
-		EnergyEvent enEvent = (EnergyEvent)event;
+		ResourceEvent enEvent = (ResourceEvent)event;
 		double load = 0;
 		try{
@@ -54,5 +54,5 @@
 				break;
 				
-			case FREQUENCY_CHANGED:
+			case CPU_FREQUENCY_CHANGED:
 				load = loadProfile.getLoadEstimationPlugin().estimateUtlization(enEvent, new JobRegistryImpl(resource.getFullName()), resource);
 				loadProfile.addToLoadHistory(load);
@@ -69,5 +69,5 @@
 				break;
 				
-			case RESOURCE_UTILIZATION_CHANGED:
+			case UTILIZATION_CHANGED:
 				load = loadProfile.getLoadEstimationPlugin().estimateUtlization(enEvent, new JobRegistryImpl(resource.getFullName()), resource);
 				loadProfile.addToLoadHistory(load);
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/load/plugin/LoadEstimationPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/load/plugin/LoadEstimationPlugin.java	(revision 1285)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/load/plugin/LoadEstimationPlugin.java	(revision 1415)
@@ -2,5 +2,5 @@
 
 import schedframe.Plugin;
-import schedframe.resources.computing.profiles.energy.EnergyEvent;
+import schedframe.resources.computing.profiles.energy.ResourceEvent;
 import schedframe.resources.devices.PhysicalResource;
 import schedframe.scheduling.manager.tasks.JobRegistry;
@@ -8,5 +8,5 @@
 public interface LoadEstimationPlugin extends Plugin {
 	
-	public double estimateUtlization(EnergyEvent event, JobRegistry jobRegistry, PhysicalResource resource);
+	public double estimateUtlization(ResourceEvent event, JobRegistry jobRegistry, PhysicalResource resource);
 
 
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/ResourceEvent.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/ResourceEvent.java	(revision 1415)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/ResourceEvent.java	(revision 1415)
@@ -0,0 +1,53 @@
+package schedframe.resources.computing.profiles.energy;
+
+import schedframe.events.Event;
+import schedframe.events.EventReason;
+import schedframe.events.EventType;
+
+
+public class ResourceEvent implements Event{
+
+	protected EventType type;
+	protected EventReason reason;
+	protected String source;
+	protected Object data;
+
+	public ResourceEvent(EventType eventType, String source){
+		this.type = eventType;
+		this.source = source;
+		setReason(EventReason.UNKNOWN);
+	}
+	
+	public ResourceEvent(EventType eventType, Object data, String source){
+		this.type = eventType;
+		this.data = data;
+		this.source = source;
+		setReason(EventReason.UNKNOWN);
+	}
+	
+	public ResourceEventType getType() {
+		ResourceEventType resEventType; 
+		try{
+			resEventType = (ResourceEventType)type;
+		} catch(Exception e){
+			resEventType = null; 
+		}
+		return resEventType;
+	}
+
+	public Object getData() {
+		return data;
+	}
+
+	public String getSource() {
+		return source;
+	}
+
+	public EventReason getReason() {
+		return reason;
+	}
+
+	public void setReason(EventReason reason) {
+		this.reason = reason;
+	}
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/ResourceEventType.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/ResourceEventType.java	(revision 1415)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/ResourceEventType.java	(revision 1415)
@@ -0,0 +1,23 @@
+package schedframe.resources.computing.profiles.energy;
+
+import schedframe.events.EventType;
+
+public enum ResourceEventType implements EventType {
+	
+	TASK_STARTED,
+	TASK_FINISHED,
+
+	POWER_STATE_CHANGED,
+	CPU_FREQUENCY_CHANGED,
+	AIRFLOW_STATE_CHANGED,
+	
+	UTILIZATION_CHANGED,
+	
+	TEMPERATURE_CHANGED,
+	
+	UPDATE_POWER_STATE;
+
+	public String getName(){
+		return toString();
+	}
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/ComputingResourcePowerInterface.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/ComputingResourcePowerInterface.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/ComputingResourcePowerInterface.java	(revision 1415)
@@ -9,6 +9,6 @@
 import schedframe.resources.ResourceStatus;
 import schedframe.resources.computing.ComputingResource;
-import schedframe.resources.computing.profiles.energy.EnergyEvent;
-import schedframe.resources.computing.profiles.energy.EnergyEventType;
+import schedframe.resources.computing.profiles.energy.ResourceEvent;
+import schedframe.resources.computing.profiles.energy.ResourceEventType;
 import schedframe.resources.computing.profiles.energy.power.PowerProfile;
 import schedframe.resources.computing.profiles.energy.power.PowerState;
@@ -49,5 +49,5 @@
 			}
 			//notifications from all levels
-			resource.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, resource.getFullName()));
+			resource.handleEvent(new ResourceEvent(ResourceEventType.POWER_STATE_CHANGED, resource.getFullName()));
 
 			//notification from last level
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/ProcessorPowerInterface.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/ProcessorPowerInterface.java	(revision 1299)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/ProcessorPowerInterface.java	(revision 1415)
@@ -6,6 +6,6 @@
 import schedframe.resources.ResourceStatus;
 import schedframe.resources.computing.ComputingResource;
-import schedframe.resources.computing.profiles.energy.EnergyEvent;
-import schedframe.resources.computing.profiles.energy.EnergyEventType;
+import schedframe.resources.computing.profiles.energy.ResourceEvent;
+import schedframe.resources.computing.profiles.energy.ResourceEventType;
 import schedframe.resources.computing.profiles.energy.power.PState;
 import schedframe.resources.computing.profiles.energy.power.PowerProfile;
@@ -33,5 +33,5 @@
 				resource.setStatus(ResourceStatus.FREE);
 			}
-			resource.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, resource.getFullName()));		
+			resource.handleEvent(new ResourceEvent(ResourceEventType.POWER_STATE_CHANGED, resource.getFullName()));		
 		}
 
@@ -67,5 +67,5 @@
 			//speed.setAmount(Double.valueOf(currentPState.getFrequency()).intValue());
 			//new ResourceEventCommand(resource).execute(EnergyEventType.FREQUENCY_CHANGED);
-			resource.handleEvent(new EnergyEvent(EnergyEventType.FREQUENCY_CHANGED, resource.getFullName()));
+			resource.handleEvent(new ResourceEvent(ResourceEventType.CPU_FREQUENCY_CHANGED, resource.getFullName()));
 			//resource.getScheduler().sendInternal(GridSimTags.SCHEDULE_NOW, DCWormsTags.UPDATE, resource.getName());
 			
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/NodePowerInterface.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/NodePowerInterface.java	(revision 1384)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/ui/NodePowerInterface.java	(revision 1415)
@@ -3,12 +3,17 @@
 
 
+import java.util.List;
+
 import schedframe.resources.ResourceStatus;
 import schedframe.resources.computing.ComputingResource;
 import schedframe.resources.computing.Node;
-import schedframe.resources.computing.profiles.energy.EnergyEvent;
-import schedframe.resources.computing.profiles.energy.EnergyEventType;
+import schedframe.resources.computing.profiles.energy.ResourceEvent;
+import schedframe.resources.computing.profiles.energy.ResourceEventType;
 import schedframe.resources.computing.profiles.energy.power.PowerProfile;
+import schedframe.resources.computing.profiles.energy.power.PowerState;
 import schedframe.resources.computing.profiles.energy.power.PowerStateName;
 import schedframe.resources.computing.profiles.energy.power.StandardPowerStateName;
+import schedframe.resources.computing.profiles.energy.power.Transition;
+import simulator.DataCenterWorkloadSimulator;
 
 public class NodePowerInterface extends ComputingResourcePowerInterface{
@@ -26,5 +31,5 @@
 			
 			Node node = (Node) resource;
-			for(ComputingResource child:node.getProcessors()){
+			for(ComputingResource child: node.getProcessors()){
 				if(child.getPowerInterface() != null){
 					child.getPowerInterface().setPowerState(state);	
@@ -39,5 +44,5 @@
 			}
 	
-			node.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, node.getFullName()));
+			node.handleEvent(new ResourceEvent(ResourceEventType.POWER_STATE_CHANGED, node.getFullName()));
 
 			//node.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, computingNode.getName()));
@@ -48,11 +53,32 @@
 
 	public void turnOn(){
+		/*double timePenalty = getTransitionTime(currentPowerState, StandardPowerStateName.ON);
+		setPowerState(StandardPowerStateName.BOOT);
+		DataCenterWorkloadSimulator.getEventManager().sendToResource(resource.getFullName(), timePenalty, new ResourceEvent(ResourceEventType.UPDATE_POWER_STATE, StandardPowerStateName.ON, resource.getFullName()));*/
 		setPowerState(StandardPowerStateName.ON);
 	}
 	
 	public void turnOff(){
+		/*double timePenalty = getTransitionTime(currentPowerState, StandardPowerStateName.OFF);
+		setPowerState(StandardPowerStateName.POWEROFF);
+		DataCenterWorkloadSimulator.getEventManager().sendToResource(resource.getFullName(), timePenalty, new ResourceEvent(ResourceEventType.UPDATE_POWER_STATE, StandardPowerStateName.OFF, resource.getFullName()));*/
 		setPowerState(StandardPowerStateName.OFF);
 	}
 
+	private double getTransitionTime(PowerStateName from, PowerStateName to){
+		List<PowerState> availablePowerStates = getSupportedPowerStates();
+		double timePenalty = 0;
+		for(PowerState ps : availablePowerStates){
+			if(ps.getName().getLabel().equals(from.getLabel())){
+				List<Transition> transitions = ps.getTransitions();
+				for(Transition t: transitions){
+					if(t.getTo().getLabel().equals(to)){
+						timePenalty = t.getTime();
+					}
+				}
+			}
+		}
+		return timePenalty;
+	}
 
 
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/plugin/EnergyPluginConfiguration.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/plugin/EnergyPluginConfiguration.java	(revision 1415)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/plugin/EnergyPluginConfiguration.java	(revision 1415)
@@ -0,0 +1,43 @@
+package schedframe.resources.computing.profiles.energy.power.plugin;
+
+import java.util.Map;
+
+import schedframe.PluginConfiguration;
+import schedframe.events.scheduling.SchedulingEventType;
+
+public class EnergyPluginConfiguration  implements PluginConfiguration {
+	
+	//private Map<SchedulingEventType, Object> events;
+	private double powerCapLevel;
+	private double powerFloorLevel;
+
+	public EnergyPluginConfiguration(){
+		//this.events = new HashMap<SchedulingEventType, Object>();
+	}
+	
+	public void addServedEvent(SchedulingEventType eventType, Object argument){
+		//events.put(eventType, argument);
+	}
+	
+	public Map<SchedulingEventType, Object> getServedEvents() {
+		//return events;
+		return null;
+	}
+
+	public double getPowerCapLevel() {
+		return powerCapLevel;
+	}
+
+	public void setPowerCapLevel(double powerCapLevel) {
+		this.powerCapLevel = powerCapLevel;
+	}
+
+	public double getPowerFloorLevel() {
+		return powerFloorLevel;
+	}
+
+	public void setPowerFloorLevel(double powerFloorLevel) {
+		this.powerFloorLevel = powerFloorLevel;
+	}
+}
+
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/plugin/EnergyEstimationPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/plugin/EnergyEstimationPlugin.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/plugin/EnergyEstimationPlugin.java	(revision 1415)
@@ -2,5 +2,5 @@
 
 import schedframe.Plugin;
-import schedframe.resources.computing.profiles.energy.EnergyEvent;
+import schedframe.resources.computing.profiles.energy.ResourceEvent;
 import schedframe.resources.devices.PhysicalResource;
 import schedframe.scheduling.manager.tasks.JobRegistry;
@@ -8,9 +8,9 @@
 public interface EnergyEstimationPlugin extends Plugin {
 	
-	public double estimatePowerConsumption(EnergyEvent event, JobRegistry jobRegistry, PhysicalResource resource);
+	public double estimatePowerConsumption(ResourceEvent event, JobRegistry jobRegistry, PhysicalResource resource);
 
-	public double estimateAirflow(EnergyEvent event, JobRegistry jobRegistry, PhysicalResource resource);
+	public double estimateAirflow(ResourceEvent event, JobRegistry jobRegistry, PhysicalResource resource);
 
-	public double estimateTemperature(EnergyEvent event, JobRegistry jobRegistry, PhysicalResource resource);
+	public double estimateTemperature(ResourceEvent event, JobRegistry jobRegistry, PhysicalResource resource);
 
 }
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/StandardPowerStateName.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/StandardPowerStateName.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/power/StandardPowerStateName.java	(revision 1415)
@@ -8,5 +8,7 @@
 	SLEEP,
 	SUSPEND,
-	HIBERNATE;
+	HIBERNATE,
+	BOOT,
+	POWEROFF;
 
 	public String getLabel() {
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/ui/ComputingResourceAirflowInterface.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/ui/ComputingResourceAirflowInterface.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/ui/ComputingResourceAirflowInterface.java	(revision 1415)
@@ -8,6 +8,6 @@
 import schedframe.Parameters;
 import schedframe.resources.computing.ComputingResource;
-import schedframe.resources.computing.profiles.energy.EnergyEvent;
-import schedframe.resources.computing.profiles.energy.EnergyEventType;
+import schedframe.resources.computing.profiles.energy.ResourceEvent;
+import schedframe.resources.computing.profiles.energy.ResourceEventType;
 import schedframe.resources.computing.profiles.energy.airthroughput.AirflowValue;
 import schedframe.resources.computing.profiles.energy.airthroughput.AirflowProfile;
@@ -37,6 +37,6 @@
 			
 			//TO DO - notifications should be called for all resources starting form the lowest layer
-			resource.handleEvent(new EnergyEvent(EnergyEventType.AIRFLOW_STATE_CHANGED, resource.getFullName()));
-			resource.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, resource.getFullName()));
+			resource.handleEvent(new ResourceEvent(ResourceEventType.AIRFLOW_STATE_CHANGED, resource.getFullName()));
+			resource.handleEvent(new ResourceEvent(ResourceEventType.POWER_STATE_CHANGED, resource.getFullName()));
 			return true;
 		}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/EnergyExtension.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/EnergyExtension.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/EnergyExtension.java	(revision 1415)
@@ -15,4 +15,5 @@
 import schedframe.resources.computing.profiles.energy.power.PowerInterfaceFactory;
 import schedframe.resources.computing.profiles.energy.power.PowerProfile;
+import schedframe.resources.computing.profiles.energy.power.PowerStateName;
 import schedframe.resources.computing.profiles.energy.power.ui.PowerInterface;
 import schedframe.resources.computing.profiles.energy.thermal.ThermalInterfaceFactory;
@@ -110,18 +111,18 @@
 		if(powerProfile == null || powerProfile.getEnergyEstimationPlugin() == null)
 			return false;
-		if(event.getType().getName().equals(EnergyEventType.POWER_STATE_CHANGED.getName()))
-			return true;
-		else if(event.getType().getName().equals(EnergyEventType.FREQUENCY_CHANGED.getName()))
-			return true;
-		else if(event.getType().getName().equals(EnergyEventType.TASK_STARTED.getName()))
-			return true;
-		else if(event.getType().getName().equals(EnergyEventType.TASK_FINISHED.getName()))
-			return true;
-		else if(event.getType().getName().equals(EnergyEventType.RESOURCE_UTILIZATION_CHANGED.getName()))
-			return true;
-	
-		if(event.getType().getName().equals(EnergyEventType.AIRFLOW_STATE_CHANGED.getName()))
-			return true;
-		if(event.getType().getName().equals(EnergyEventType.TEMPERATURE_CHANGED.getName()))
+		if(event.getType().getName().equals(ResourceEventType.POWER_STATE_CHANGED.getName()))
+			return true;
+		else if(event.getType().getName().equals(ResourceEventType.CPU_FREQUENCY_CHANGED.getName()))
+			return true;
+		else if(event.getType().getName().equals(ResourceEventType.TASK_STARTED.getName()))
+			return true;
+		else if(event.getType().getName().equals(ResourceEventType.TASK_FINISHED.getName()))
+			return true;
+		else if(event.getType().getName().equals(ResourceEventType.UTILIZATION_CHANGED.getName()))
+			return true;
+	
+		if(event.getType().getName().equals(ResourceEventType.AIRFLOW_STATE_CHANGED.getName()))
+			return true;
+		if(event.getType().getName().equals(ResourceEventType.TEMPERATURE_CHANGED.getName()))
 			return true;
 		
@@ -131,42 +132,47 @@
 	public void handleEvent(Event event) {
 		
-		EnergyEvent enEvent = (EnergyEvent)event;
+		ResourceEvent resEvent = (ResourceEvent)event;
 		double power = 0;
 		boolean status = false;
 		try{
-			switch (enEvent.getType()) {
+			switch (resEvent.getType()) {
 			
+			case UPDATE_POWER_STATE:
+				PowerStateName newPowerState = (PowerStateName) resEvent.getData();
+				powerInterface.setPowerState(newPowerState);
+				break;
+				
 			case POWER_STATE_CHANGED:
-				power = powerProfile.getEnergyEstimationPlugin().estimatePowerConsumption(enEvent, new JobRegistryImpl(resource.getFullName()), resource);			
-				status = powerProfile.addToPowerUsageHistory(power);
-				break;
-				
-			case FREQUENCY_CHANGED:
-				power = powerProfile.getEnergyEstimationPlugin().estimatePowerConsumption(enEvent, new JobRegistryImpl(resource.getFullName()), resource);
+				power = powerProfile.getEnergyEstimationPlugin().estimatePowerConsumption(resEvent, new JobRegistryImpl(resource.getFullName()), resource);			
+				status = powerProfile.addToPowerUsageHistory(power);
+				break;
+				
+			case CPU_FREQUENCY_CHANGED:
+				power = powerProfile.getEnergyEstimationPlugin().estimatePowerConsumption(resEvent, new JobRegistryImpl(resource.getFullName()), resource);
 				status = powerProfile.addToPowerUsageHistory(power);
 				break;
 				
 			case TASK_STARTED:
-				power = powerProfile.getEnergyEstimationPlugin().estimatePowerConsumption(enEvent, new JobRegistryImpl(resource.getFullName()), resource);
+				power = powerProfile.getEnergyEstimationPlugin().estimatePowerConsumption(resEvent, new JobRegistryImpl(resource.getFullName()), resource);
 				status = powerProfile.addToPowerUsageHistory(power);
 				break;
 	
 			case TASK_FINISHED:
-				power = powerProfile.getEnergyEstimationPlugin().estimatePowerConsumption(enEvent, new JobRegistryImpl(resource.getFullName()), resource);
-				status = powerProfile.addToPowerUsageHistory(power);
-				break;
-				
-			case RESOURCE_UTILIZATION_CHANGED:
-				power = powerProfile.getEnergyEstimationPlugin().estimatePowerConsumption(enEvent, new JobRegistryImpl(resource.getFullName()), resource);
+				power = powerProfile.getEnergyEstimationPlugin().estimatePowerConsumption(resEvent, new JobRegistryImpl(resource.getFullName()), resource);
+				status = powerProfile.addToPowerUsageHistory(power);
+				break;
+				
+			case UTILIZATION_CHANGED:
+				power = powerProfile.getEnergyEstimationPlugin().estimatePowerConsumption(resEvent, new JobRegistryImpl(resource.getFullName()), resource);
 				status = powerProfile.addToPowerUsageHistory(power);
 				break;
 				
 			case AIRFLOW_STATE_CHANGED:
-				double airflow = powerProfile.getEnergyEstimationPlugin().estimateAirflow(enEvent, new JobRegistryImpl(resource.getFullName()), resource);
+				double airflow = powerProfile.getEnergyEstimationPlugin().estimateAirflow(resEvent, new JobRegistryImpl(resource.getFullName()), resource);
 				airflowProfile.addToAirFlowHistory(airflow);
 				break;
 				
 			case TEMPERATURE_CHANGED:
-				double temperature = powerProfile.getEnergyEstimationPlugin().estimateTemperature(enEvent, new JobRegistryImpl(resource.getFullName()), resource);
+				double temperature = powerProfile.getEnergyEstimationPlugin().estimateTemperature(resEvent, new JobRegistryImpl(resource.getFullName()), resource);
 				thermalProfile.addToTemperatureHistory(temperature);
 				break;
@@ -176,5 +182,5 @@
 		}
 		if(status){
-			DataCenterWorkloadSimulator.getEventManager().sendToResources(resource.getType(), 0, new EnergyEvent(EnergyEventType.TEMPERATURE_CHANGED, resource.getFullName()));
+			DataCenterWorkloadSimulator.getEventManager().sendToResources(resource.getType(), 0, new ResourceEvent(ResourceEventType.TEMPERATURE_CHANGED, resource.getFullName()));
 		}
 	}
